module GI.Gtk.Objects.Widget where

import Data.GI.Base.ShortPrelude

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype Widget = Widget (ForeignPtr Widget)
instance GObject Widget where
class GObject o => WidgetK o
instance (GObject o, IsDescendantOf Widget o) => WidgetK o
data WidgetAppPaintablePropertyInfo
data WidgetCanDefaultPropertyInfo
data WidgetCanFocusPropertyInfo
data WidgetCompositeChildPropertyInfo
data WidgetDoubleBufferedPropertyInfo
data WidgetEventsPropertyInfo
data WidgetExpandPropertyInfo
data WidgetHalignPropertyInfo
data WidgetHasDefaultPropertyInfo
data WidgetHasFocusPropertyInfo
data WidgetHasTooltipPropertyInfo
data WidgetHeightRequestPropertyInfo
data WidgetHexpandPropertyInfo
data WidgetHexpandSetPropertyInfo
data WidgetIsFocusPropertyInfo
data WidgetMarginPropertyInfo
data WidgetMarginBottomPropertyInfo
data WidgetMarginEndPropertyInfo
data WidgetMarginLeftPropertyInfo
data WidgetMarginRightPropertyInfo
data WidgetMarginStartPropertyInfo
data WidgetMarginTopPropertyInfo
data WidgetNamePropertyInfo
data WidgetNoShowAllPropertyInfo
data WidgetOpacityPropertyInfo
data WidgetParentPropertyInfo
data WidgetReceivesDefaultPropertyInfo
data WidgetScaleFactorPropertyInfo
data WidgetSensitivePropertyInfo
data WidgetStylePropertyInfo
data WidgetTooltipMarkupPropertyInfo
data WidgetTooltipTextPropertyInfo
data WidgetValignPropertyInfo
data WidgetVexpandPropertyInfo
data WidgetVexpandSetPropertyInfo
data WidgetVisiblePropertyInfo
data WidgetWidthRequestPropertyInfo
data WidgetWindowPropertyInfo
data WidgetAccelClosuresChangedSignalInfo
data WidgetButtonPressEventSignalInfo
data WidgetButtonReleaseEventSignalInfo
data WidgetCanActivateAccelSignalInfo
data WidgetChildNotifySignalInfo
data WidgetCompositedChangedSignalInfo
data WidgetConfigureEventSignalInfo
data WidgetDamageEventSignalInfo
data WidgetDeleteEventSignalInfo
data WidgetDestroySignalInfo
data WidgetDestroyEventSignalInfo
data WidgetDirectionChangedSignalInfo
data WidgetDragBeginSignalInfo
data WidgetDragDataDeleteSignalInfo
data WidgetDragDataGetSignalInfo
data WidgetDragDataReceivedSignalInfo
data WidgetDragDropSignalInfo
data WidgetDragEndSignalInfo
data WidgetDragFailedSignalInfo
data WidgetDragLeaveSignalInfo
data WidgetDragMotionSignalInfo
data WidgetDrawSignalInfo
data WidgetEnterNotifyEventSignalInfo
data WidgetEventSignalInfo
data WidgetEventAfterSignalInfo
data WidgetFocusSignalInfo
data WidgetFocusInEventSignalInfo
data WidgetFocusOutEventSignalInfo
data WidgetGrabBrokenEventSignalInfo
data WidgetGrabFocusSignalInfo
data WidgetGrabNotifySignalInfo
data WidgetHideSignalInfo
data WidgetHierarchyChangedSignalInfo
data WidgetKeyPressEventSignalInfo
data WidgetKeyReleaseEventSignalInfo
data WidgetKeynavFailedSignalInfo
data WidgetLeaveNotifyEventSignalInfo
data WidgetMapSignalInfo
data WidgetMapEventSignalInfo
data WidgetMnemonicActivateSignalInfo
data WidgetMotionNotifyEventSignalInfo
data WidgetMoveFocusSignalInfo
data WidgetParentSetSignalInfo
data WidgetPopupMenuSignalInfo
data WidgetPropertyNotifyEventSignalInfo
data WidgetProximityInEventSignalInfo
data WidgetProximityOutEventSignalInfo
data WidgetQueryTooltipSignalInfo
data WidgetRealizeSignalInfo
data WidgetScreenChangedSignalInfo
data WidgetScrollEventSignalInfo
data WidgetSelectionClearEventSignalInfo
data WidgetSelectionGetSignalInfo
data WidgetSelectionNotifyEventSignalInfo
data WidgetSelectionReceivedSignalInfo
data WidgetSelectionRequestEventSignalInfo
data WidgetShowSignalInfo
data WidgetShowHelpSignalInfo
data WidgetSizeAllocateSignalInfo
data WidgetStateChangedSignalInfo
data WidgetStateFlagsChangedSignalInfo
data WidgetStyleSetSignalInfo
data WidgetStyleUpdatedSignalInfo
data WidgetTouchEventSignalInfo
data WidgetUnmapSignalInfo
data WidgetUnmapEventSignalInfo
data WidgetUnrealizeSignalInfo
data WidgetVisibilityNotifyEventSignalInfo
data WidgetWindowStateEventSignalInfo
data WidgetActivateMethodInfo
data WidgetAddAcceleratorMethodInfo
data WidgetAddDeviceEventsMethodInfo
data WidgetAddEventsMethodInfo
data WidgetAddMnemonicLabelMethodInfo
data WidgetAddTickCallbackMethodInfo
data WidgetCanActivateAccelMethodInfo
data WidgetChildFocusMethodInfo
data WidgetChildNotifyMethodInfo
data WidgetClassPathMethodInfo
data WidgetComputeExpandMethodInfo
data WidgetCreatePangoContextMethodInfo
data WidgetCreatePangoLayoutMethodInfo
data WidgetDestroyMethodInfo
data WidgetDestroyedMethodInfo
data WidgetDeviceIsShadowedMethodInfo
data WidgetDragBeginMethodInfo
data WidgetDragBeginWithCoordinatesMethodInfo
data WidgetDragCheckThresholdMethodInfo
data WidgetDragDestAddImageTargetsMethodInfo
data WidgetDragDestAddTextTargetsMethodInfo
data WidgetDragDestAddUriTargetsMethodInfo
data WidgetDragDestFindTargetMethodInfo
data WidgetDragDestGetTargetListMethodInfo
data WidgetDragDestGetTrackMotionMethodInfo
data WidgetDragDestSetMethodInfo
data WidgetDragDestSetProxyMethodInfo
data WidgetDragDestSetTargetListMethodInfo
data WidgetDragDestSetTrackMotionMethodInfo
data WidgetDragDestUnsetMethodInfo
data WidgetDragGetDataMethodInfo
data WidgetDragHighlightMethodInfo
data WidgetDragSourceAddImageTargetsMethodInfo
data WidgetDragSourceAddTextTargetsMethodInfo
data WidgetDragSourceAddUriTargetsMethodInfo
data WidgetDragSourceGetTargetListMethodInfo
data WidgetDragSourceSetMethodInfo
data WidgetDragSourceSetIconGiconMethodInfo
data WidgetDragSourceSetIconNameMethodInfo
data WidgetDragSourceSetIconPixbufMethodInfo
data WidgetDragSourceSetIconStockMethodInfo
data WidgetDragSourceSetTargetListMethodInfo
data WidgetDragSourceUnsetMethodInfo
data WidgetDragUnhighlightMethodInfo
data WidgetDrawMethodInfo
data WidgetEnsureStyleMethodInfo
data WidgetErrorBellMethodInfo
data WidgetEventMethodInfo
data WidgetFreezeChildNotifyMethodInfo
data WidgetGetAccessibleMethodInfo
data WidgetGetActionGroupMethodInfo
data WidgetGetAllocatedBaselineMethodInfo
data WidgetGetAllocatedHeightMethodInfo
data WidgetGetAllocatedWidthMethodInfo
data WidgetGetAllocationMethodInfo
data WidgetGetAncestorMethodInfo
data WidgetGetAppPaintableMethodInfo
data WidgetGetCanDefaultMethodInfo
data WidgetGetCanFocusMethodInfo
data WidgetGetChildRequisitionMethodInfo
data WidgetGetChildVisibleMethodInfo
data WidgetGetClipMethodInfo
data WidgetGetClipboardMethodInfo
data WidgetGetCompositeNameMethodInfo
data WidgetGetDeviceEnabledMethodInfo
data WidgetGetDeviceEventsMethodInfo
data WidgetGetDirectionMethodInfo
data WidgetGetDisplayMethodInfo
data WidgetGetDoubleBufferedMethodInfo
data WidgetGetEventsMethodInfo
data WidgetGetFontMapMethodInfo
data WidgetGetFontOptionsMethodInfo
data WidgetGetFrameClockMethodInfo
data WidgetGetHalignMethodInfo
data WidgetGetHasTooltipMethodInfo
data WidgetGetHasWindowMethodInfo
data WidgetGetHexpandMethodInfo
data WidgetGetHexpandSetMethodInfo
data WidgetGetMappedMethodInfo
data WidgetGetMarginBottomMethodInfo
data WidgetGetMarginEndMethodInfo
data WidgetGetMarginLeftMethodInfo
data WidgetGetMarginRightMethodInfo
data WidgetGetMarginStartMethodInfo
data WidgetGetMarginTopMethodInfo
data WidgetGetModifierMaskMethodInfo
data WidgetGetModifierStyleMethodInfo
data WidgetGetNameMethodInfo
data WidgetGetNoShowAllMethodInfo
data WidgetGetOpacityMethodInfo
data WidgetGetPangoContextMethodInfo
data WidgetGetParentMethodInfo
data WidgetGetParentWindowMethodInfo
data WidgetGetPathMethodInfo
data WidgetGetPointerMethodInfo
data WidgetGetPreferredHeightMethodInfo
data WidgetGetPreferredHeightAndBaselineForWidthMethodInfo
data WidgetGetPreferredHeightForWidthMethodInfo
data WidgetGetPreferredSizeMethodInfo
data WidgetGetPreferredWidthMethodInfo
data WidgetGetPreferredWidthForHeightMethodInfo
data WidgetGetRealizedMethodInfo
data WidgetGetReceivesDefaultMethodInfo
data WidgetGetRequestModeMethodInfo
data WidgetGetRequisitionMethodInfo
data WidgetGetRootWindowMethodInfo
data WidgetGetScaleFactorMethodInfo
data WidgetGetScreenMethodInfo
data WidgetGetSensitiveMethodInfo
data WidgetGetSettingsMethodInfo
data WidgetGetSizeRequestMethodInfo
data WidgetGetStateMethodInfo
data WidgetGetStateFlagsMethodInfo
data WidgetGetStyleMethodInfo
data WidgetGetStyleContextMethodInfo
data WidgetGetSupportMultideviceMethodInfo
data WidgetGetTemplateChildMethodInfo
data WidgetGetTooltipMarkupMethodInfo
data WidgetGetTooltipTextMethodInfo
data WidgetGetTooltipWindowMethodInfo
data WidgetGetToplevelMethodInfo
data WidgetGetValignMethodInfo
data WidgetGetValignWithBaselineMethodInfo
data WidgetGetVexpandMethodInfo
data WidgetGetVexpandSetMethodInfo
data WidgetGetVisibleMethodInfo
data WidgetGetVisualMethodInfo
data WidgetGetWindowMethodInfo
data WidgetGrabAddMethodInfo
data WidgetGrabDefaultMethodInfo
data WidgetGrabFocusMethodInfo
data WidgetGrabRemoveMethodInfo
data WidgetHasDefaultMethodInfo
data WidgetHasFocusMethodInfo
data WidgetHasGrabMethodInfo
data WidgetHasRcStyleMethodInfo
data WidgetHasScreenMethodInfo
data WidgetHasVisibleFocusMethodInfo
data WidgetHideMethodInfo
data WidgetHideOnDeleteMethodInfo
data WidgetInDestructionMethodInfo
data WidgetInitTemplateMethodInfo
data WidgetInputShapeCombineRegionMethodInfo
data WidgetInsertActionGroupMethodInfo
data WidgetIntersectMethodInfo
data WidgetIsAncestorMethodInfo
data WidgetIsCompositedMethodInfo
data WidgetIsDrawableMethodInfo
data WidgetIsFocusMethodInfo
data WidgetIsSensitiveMethodInfo
data WidgetIsToplevelMethodInfo
data WidgetIsVisibleMethodInfo
data WidgetKeynavFailedMethodInfo
data WidgetListAccelClosuresMethodInfo
data WidgetListActionPrefixesMethodInfo
data WidgetListMnemonicLabelsMethodInfo
data WidgetMapMethodInfo
data WidgetMnemonicActivateMethodInfo
data WidgetModifyBaseMethodInfo
data WidgetModifyBgMethodInfo
data WidgetModifyCursorMethodInfo
data WidgetModifyFgMethodInfo
data WidgetModifyFontMethodInfo
data WidgetModifyStyleMethodInfo
data WidgetModifyTextMethodInfo
data WidgetOverrideBackgroundColorMethodInfo
data WidgetOverrideColorMethodInfo
data WidgetOverrideCursorMethodInfo
data WidgetOverrideFontMethodInfo
data WidgetOverrideSymbolicColorMethodInfo
data WidgetPathMethodInfo
data WidgetQueueComputeExpandMethodInfo
data WidgetQueueDrawMethodInfo
data WidgetQueueDrawAreaMethodInfo
data WidgetQueueDrawRegionMethodInfo
data WidgetQueueResizeMethodInfo
data WidgetQueueResizeNoRedrawMethodInfo
data WidgetRealizeMethodInfo
data WidgetRegionIntersectMethodInfo
data WidgetRegisterWindowMethodInfo
data WidgetRemoveAcceleratorMethodInfo
data WidgetRemoveMnemonicLabelMethodInfo
data WidgetRemoveTickCallbackMethodInfo
data WidgetRenderIconMethodInfo
data WidgetRenderIconPixbufMethodInfo
data WidgetReparentMethodInfo
data WidgetResetRcStylesMethodInfo
data WidgetResetStyleMethodInfo
data WidgetSendExposeMethodInfo
data WidgetSendFocusChangeMethodInfo
data WidgetSetAccelPathMethodInfo
data WidgetSetAllocationMethodInfo
data WidgetSetAppPaintableMethodInfo
data WidgetSetCanDefaultMethodInfo
data WidgetSetCanFocusMethodInfo
data WidgetSetChildVisibleMethodInfo
data WidgetSetClipMethodInfo
data WidgetSetCompositeNameMethodInfo
data WidgetSetDeviceEnabledMethodInfo
data WidgetSetDeviceEventsMethodInfo
data WidgetSetDirectionMethodInfo
data WidgetSetDoubleBufferedMethodInfo
data WidgetSetEventsMethodInfo
data WidgetSetFontMapMethodInfo
data WidgetSetFontOptionsMethodInfo
data WidgetSetHalignMethodInfo
data WidgetSetHasTooltipMethodInfo
data WidgetSetHasWindowMethodInfo
data WidgetSetHexpandMethodInfo
data WidgetSetHexpandSetMethodInfo
data WidgetSetMappedMethodInfo
data WidgetSetMarginBottomMethodInfo
data WidgetSetMarginEndMethodInfo
data WidgetSetMarginLeftMethodInfo
data WidgetSetMarginRightMethodInfo
data WidgetSetMarginStartMethodInfo
data WidgetSetMarginTopMethodInfo
data WidgetSetNameMethodInfo
data WidgetSetNoShowAllMethodInfo
data WidgetSetOpacityMethodInfo
data WidgetSetParentMethodInfo
data WidgetSetParentWindowMethodInfo
data WidgetSetRealizedMethodInfo
data WidgetSetReceivesDefaultMethodInfo
data WidgetSetRedrawOnAllocateMethodInfo
data WidgetSetSensitiveMethodInfo
data WidgetSetSizeRequestMethodInfo
data WidgetSetStateMethodInfo
data WidgetSetStateFlagsMethodInfo
data WidgetSetStyleMethodInfo
data WidgetSetSupportMultideviceMethodInfo
data WidgetSetTooltipMarkupMethodInfo
data WidgetSetTooltipTextMethodInfo
data WidgetSetTooltipWindowMethodInfo
data WidgetSetValignMethodInfo
data WidgetSetVexpandMethodInfo
data WidgetSetVexpandSetMethodInfo
data WidgetSetVisibleMethodInfo
data WidgetSetVisualMethodInfo
data WidgetSetWindowMethodInfo
data WidgetShapeCombineRegionMethodInfo
data WidgetShowMethodInfo
data WidgetShowAllMethodInfo
data WidgetShowNowMethodInfo
data WidgetSizeAllocateMethodInfo
data WidgetSizeAllocateWithBaselineMethodInfo
data WidgetSizeRequestMethodInfo
data WidgetStyleAttachMethodInfo
data WidgetStyleGetPropertyMethodInfo
data WidgetThawChildNotifyMethodInfo
data WidgetTranslateCoordinatesMethodInfo
data WidgetTriggerTooltipQueryMethodInfo
data WidgetUnmapMethodInfo
data WidgetUnparentMethodInfo
data WidgetUnrealizeMethodInfo
data WidgetUnregisterWindowMethodInfo
data WidgetUnsetStateFlagsMethodInfo
